Option Strict Off
Option Explicit On
Friend Class clsAddOrder
	
	Public Function AddNewOrder(ByVal strServer As String, ByVal strUser As String, ByVal strPwd As String, ByVal lngCustID As Integer, ByVal datOrderDate As Date, ByVal datRequiredDate As Date, ByVal blnPartialShip As Boolean, ByVal bytCardID As Byte, ByVal bytShipToID As Byte, ByVal bytShipTypeID As Byte, ByVal blnSalesTax As Boolean) As Integer
		
		'Creates and passes a connection to AddNewOrderConn
		Dim cnnOrder As New ADODB.Connection
		Dim strOrderConn As String
		
		On Error Resume Next
		
		strOrderConn = "Provider=SQLOLEDB;Data Source=" & strServer & ";Initial Catalog=OCE_Cust;UID=" & strUser & ";PWD=" & strPwd
		cnnOrder.Open(strOrderConn)
		If Err.Number <> 0 Then
			'Connection failed
			AddNewOrder = -1
			Exit Function
		End If
		AddNewOrder = AddNewOrderConn(cnnOrder, lngCustID, datOrderDate, datRequiredDate, blnPartialShip, bytCardID, bytShipToID, bytShipTypeID, blnSalesTax)
		
		cnnOrder.Close()
    End Function

    Public Function AddNewOrderConn(ByRef cnnOrder As ADODB.Connection, ByVal lngCustID As Integer, ByVal datOrderDate As Date, ByVal datRequiredDate As Date, ByVal blnPartialShip As Boolean, ByVal bytCardID As Byte, ByVal bytShipToID As Byte, ByVal bytShipTypeID As Byte, ByVal blnSalesTax As Boolean) As Integer

        'Adds a new order; returns OrderID if successful, error code if not.
        Dim rstOrder As New ADODB.Recordset()
        Dim strSQL As String
        Dim strPartialShip As String
        Dim strSalesTax As String
        Dim lngReccnt As Integer

        On Error Resume Next

        If blnPartialShip Then
            strPartialShip = "1"
        Else
            strPartialShip = "0"
        End If
        If blnSalesTax Then
            strSalesTax = "1"
        Else
            strSalesTax = "0"
        End If

        strSQL = "INSERT Orders(CustID, OrderDate, RequiredShipDate, " & "PartialShipOK, CardID, ShipTypeID, SalesTaxApplies, StatusID) " & "VALUES(" & lngCustID & ", '" & datOrderDate & "' , "
        If Year(datRequiredDate) = 1899 Then
            strSQL = strSQL & "NULL"
        Else
            strSQL = strSQL & "'" & datRequiredDate & "'"
        End If
        strSQL = strSQL & ", " & strPartialShip & ", " & bytCardID & ", " & bytShipTypeID & ", " & strSalesTax & ", 11)"

        cnnOrder.Execute(strSQL, lngReccnt, ADODB.CommandTypeEnum.adCmdText)
        If Err.Number <> 0 Then
            'Execution failed
            AddNewOrderConn = -2
            Exit Function
        End If

        If CInt(lngReccnt) > 0 Then
            'Get the identity value for the connection
            strSQL = "SELECT @@identity"
            rstOrder = cnnOrder.Execute(strSQL, , ADODB.CommandTypeEnum.adCmdText)
            If Err.Number <> 0 Then
                'Execution failed
                AddNewOrderConn = -3
                Exit Function
            End If

            With rstOrder
                If .EOF Then
                    'Couldn't find the order
                    AddNewOrderConn = -4
                Else
                    'Get the OrderID
                    AddNewOrderConn = CInt(.Fields(0).Value)
                End If
                .Close()
            End With
        Else
            'Didn't add order
            AddNewOrderConn = -1
        End If
    End Function

    Public Function AddLineItem(ByVal strServer As String, ByVal strUser As String, ByVal strPwd As String, ByVal lngOrderID As Integer, ByVal bytItemID As Byte, ByVal bytQuan As Byte, ByVal strSKU As String, ByVal bytOutsourced As Byte, ByVal curUnitPrice As Decimal, ByVal sngDiscount As Single, ByVal curAllowance As Decimal, ByVal bytAllowType As Byte) As Decimal

        'Creates and passes a connection to AddLineItemConn
        Dim cnnItem As New ADODB.Connection()
        Dim strItemConn As String

        On Error Resume Next

        strItemConn = "Provider=SQLOLEDB;Data Source=" & strServer & ";Initial Catalog=OCE_Cust;UID=" & strUser & ";PWD=" & strPwd
        cnnItem.Open(strItemConn)

        If Err.Number <> 0 Then
            'Connection failed error
            AddLineItem = -1
            Exit Function
        End If

        'Pass the connection to the operative function
        AddLineItem = AddLineItemConn(cnnItem, lngOrderID, bytItemID, bytQuan, strSKU, bytOutsourced, curUnitPrice, sngDiscount, curAllowance, bytAllowType)
        If Err.Number <> 0 Then
            'Function call failed
            AddLineItem = -2
        End If
        cnnItem.Close()
    End Function

    Public Function AddLineItemConn(ByRef cnnItem As ADODB.Connection, ByVal lngOrderID As Integer, ByVal bytItemID As Byte, ByVal bytQuan As Byte, ByVal strSKU As String, ByVal bytOutsourced As Byte, ByVal curUnitPrice As Decimal, ByVal sngDiscount As Single, ByVal curAllowance As Decimal, ByVal bytAllowType As Byte) As Decimal

        Dim strSQL As String
        Dim lngReccnt As Integer

        On Error Resume Next

        strSQL = "INSERT LineItems VALUES(" & CStr(lngOrderID) & ", " & CStr(bytItemID) & ", " & CStr(bytQuan) & ", '" & strSKU & "', " & bytOutsourced & ", " & curUnitPrice & ", " & sngDiscount & ", " & curAllowance & ", " & bytAllowType & ", 11, NULL, 0)"

        cnnItem.Execute(strSQL, lngReccnt, ADODB.CommandTypeEnum.adCmdText)
        If Err.Number <> 0 Then
            AddLineItemConn = -3
        End If
        If CInt(lngReccnt) > 0 Then
            AddLineItemConn = curUnitPrice * CDec(bytQuan)
        Else
            'Line item not added
            AddLineItemConn = 0
        End If
    End Function
End Class