Option Strict Off
Option Explicit On
Friend Class clsFulfillOrder
	
    Public Function CheckOrCommit(ByVal strServer As String, ByVal strUser As String, ByVal strPwd As String, ByRef astrLineItems As System.Array, ByVal blnCommit As Boolean, ByVal blnUseWS As Boolean, ByVal blnUseOakLeaf As Boolean, ByVal blnUseCom As Boolean) As Short

        'Check warehouse and distributor inventory level
        'Commit warehouse inventory if blnCommit is True

        Dim cnnStock As New ADODB.Connection()
        Dim rstStock As New ADODB.Recordset()
        Dim strStockConn As String
        Dim strSQL As String
        Dim strSQLItem As String
        Dim strSQLUpdate As String
        Dim bytItem As Byte
        Dim sngWeight As Single
        Dim curAmount As Decimal
        Dim intInStock As Short
        Dim lngReccnt As Integer
        Dim strOutsource As String
        Dim objSoapClient As New MSSOAPLib.SoapClient()

        On Error Resume Next

        strSQL = "SELECT NetPrice, ShipWeight, Outsourced, BeginningInventory, " & "ReceivedInPeriod, ShippedInPeriod, CommittedNow FROM Products WHERE SKU = '"

        strStockConn = "Provider=SQLOLEDB;Data Source=" & strServer & ";Initial Catalog=OCE_Prod;UID=" & strUser & ";PWD=" & strPwd
        cnnStock.Open(strStockConn)
        If Err.Number <> 0 Then
            'Can't connect
            CheckOrCommit = -1
        End If
        With cnnStock
            If blnCommit Then
                .BeginTrans()
            End If
            For bytItem = 0 To UBound(astrLineItems) - 1
                strSQLItem = strSQL & astrLineItems(bytItem, 0) & "'"
                rstStock = .Execute(strSQLItem, , ADODB.CommandTypeEnum.adCmdText)
                If Err.Number <> 0 Then
                    'Can't execute query
                    CheckOrCommit = -1
                    GoTo ExitCheckOrCommit
                End If
                With rstStock
                    If .EOF Then
                        'Can't find item
                        CheckOrCommit = -3
                        If blnCommit Then
                            cnnStock.RollbackTrans()
                        End If
                        GoTo ExitCheckOrCommit
                    Else
                        If CBool(.Fields(2).Value) Then
                            'It's outsourced, return the DistID value
                            astrLineItems(bytItem, 2) = GetDistInventory(strServer, strUser, strPwd, astrLineItems(bytItem, 0), CByte(astrLineItems(bytItem, 1)), blnUseWS, blnUseOakLeaf, blnUseCom)
                        Else
                            'Get current stock (Beginning + Received - Shipped - Committed)
                            'Partial shipments make it possible to overcommit inventory (negative value)
                            intInStock = CShort(.Fields(3).Value) + CShort(.Fields(4).Value) - CShort(.Fields(5).Value) - CShort(.Fields(6).Value)
                            If intInStock >= CByte(astrLineItems(bytItem, 1)) Then
                                astrLineItems(bytItem, 2) = "Yes"
                            Else
                                astrLineItems(bytItem, 2) = "No"
                            End If
                            If blnCommit Then
                                'Commit the inventory
                                strSQLUpdate = "UPDATE Products SET CommittedNow = CommittedNow + " & astrLineItems(bytItem, 1) & "WHERE SKU = '" & astrLineItems(bytItem, 0) & "'"
                                cnnStock.Execute(strSQLUpdate, lngReccnt, ADODB.CommandTypeEnum.adCmdText)
                                If Err.Number <> 0 Or lngReccnt <> 1 Then
                                    'Unable to commit inventory
                                    cnnStock.RollbackTrans()
                                    CheckOrCommit = -4
                                    GoTo ExitCheckOrCommit
                                End If
                            End If
                        End If
                        'Weight per item
                        astrLineItems(bytItem, 3) = CStr(.Fields(1).Value)
                    End If
                End With
            Next bytItem
            If blnCommit Then
                'Commit the inventory
                .CommitTrans()
            End If
        End With
        CheckOrCommit = CShort(bytItem)

ExitCheckOrCommit:
        'Standard cleanup
        With rstStock
            If .State = ADODB.ObjectStateEnum.adStateOpen Then
                FileClose()
            End If
        End With
        With cnnStock
            If .State = ADODB.ObjectStateEnum.adStateOpen Then
                FileClose()
            End If
        End With
    End Function

    Private Function GetDistInventory(ByVal strProdServer As String, ByVal strProdUser As String, ByVal strProdPwd As String, ByVal strSKU As String, ByVal bytQuan As Byte, ByVal blnUseWS As Boolean, ByVal blnUseOakleaf As Boolean, ByVal blnUseCom As Boolean) As String

        'Check specified distributors for inventory of SKU
        'Dim objSoapClient as object
        'Dim objSoapClient As New MSSOAPLib.SoapClient()
        Dim objAlphaWS As New AlphaWS.AlphaDist()
        Dim remAlphaWS As New AlphaWSRem.AlphaDist()
        Dim comAlphaWS As New AlphaWSCom.AlphaDist()
        Dim objBetaWS As New BetaWS.BetaDist()
        Dim remBetaWS As New BetaWSRem.BetaDist()
        Dim comBetaWS As New BetaWSCom.BetaDist()
        Dim objGammaWS As New GammaWS.GammaDist()
        Dim remGammaWS As New GammaWSRem.GammaDist()
        Dim comGammaWS As New GammaWSCom.GammaDist()

        Dim cnnProd As New ADODB.Connection()
        Dim rstProd As New ADODB.Recordset()
        Dim rstBrand As New ADODB.Recordset()
        Dim rstDist As New ADODB.Recordset()
        Dim docDist As New MSXML2.DOMDocument40()
        Dim lstDist As MSXML2.IXMLDOMNodeList
        Dim nodDist As MSXML2.IXMLDOMNode

        Dim strProdConn As String
        Dim strSQL As String
        'Added fixed dimensions for Visual Basic .NET
        Dim astrResponse(3, 2) As String
        Dim bytDist As Byte
        Dim bytCtr As Byte
        Dim strDistConn As String
        Dim strServiceURL As String
        Dim strQuan As String

        On Error Resume Next

        strProdConn = "Provider=SQLOLEDB;Data Source=" & strProdServer & ";Initial Catalog=OCE_Prod;UID=" & strProdUser & ";PWD=" & strProdPwd
        cnnProd.Open(strProdConn)
        Dim objAlphaInv As New AlphaDist.clsAlphaDist()
        Dim objBetaInv As New BetaDist.clsBetaDist()
        Dim objGammaInv As New GammaDist.clsGammaDist()
        If Err.Number = 0 Then
            strSQL = "SELECT BrandID, Cost FROM Products WHERE SKU = '" & strSKU & "'"
            rstProd = cnnProd.Execute(strSQL, , ADODB.CommandTypeEnum.adCmdText)

            If rstProd.EOF Then
                'Shouldn't occur
                astrResponse(bytDist, 1) = "NONE"
                astrResponse(bytDist, 2) = "Error: No record for SKU " & strSKU
            Else
                strSQL = "SELECT DistID FROM BrandDistributor WHERE BrandID = '" & CStr(rstProd.Fields(0).Value) & "'"
                rstBrand = cnnProd.Execute(strSQL, , ADODB.CommandTypeEnum.adCmdText)
                With rstBrand
                    If .EOF Then
                        astrResponse(bytDist, 1) = "NONE"
                        astrResponse(bytDist, 2) = "Error: No distributor for BrandID " & CStr(rstProd.Fields(0).Value)
                    Else
                        bytDist = 0
                        Do Until .EOF
                            'Query each distributor
                            strSQL = "SELECT DistID, InventoryWS, ServerName, [Database], UserName, " & "Password, InventoryWS " & "FROM Distributors WHERE DistID = '" & CStr(.Fields(0).Value) & "'"
                            rstDist = cnnProd.Execute(strSQL, , ADODB.CommandTypeEnum.adCmdText)
                            With rstDist
                                '1-based array
                                bytDist = bytDist + 1
                                If .EOF Then
                                    'No distributor for this product
                                    astrResponse(bytDist, 1) = "NONE"
                                    astrResponse(bytDist, 2) = "Error: No distributor for SKU " & strSKU
                                Else
                                    astrResponse(bytDist, 1) = CStr(.Fields(0).Value)
                                    Select Case CStr(.Fields(0).Value)
                                        Case "ALPH"
                                            If blnUseWS Then
                                                If blnUseOakleaf Then
                                                   If blnUseCom Then
                                                      astrResponse(bytDist, 2) = comAlphaWS.CheckStock(CStr(.Fields(2).Value), CStr(.Fields(3).Value), CStr(.Fields(4).Value), CStr(.Fields(5).Value), strSKU, True)
                                                   Else
                                                      astrResponse(bytDist, 2) = remAlphaWS.CheckStock(CStr(.Fields(2).Value), CStr(.Fields(3).Value), CStr(.Fields(4).Value), CStr(.Fields(5).Value), strSKU, True)
                                                   End If
                                                Else
                                                   astrResponse(bytDist, 2) = objAlphaWS.CheckStock(CStr(.Fields(2).Value), CStr(.Fields(3).Value), CStr(.Fields(4).Value), CStr(.Fields(5).Value), strSKU, True)
                                                End If
                                            Else
                                                astrResponse(bytDist, 2) = objAlphaInv.CheckStock(CStr(.Fields(2).Value), CStr(.Fields(3).Value), CStr(.Fields(4).Value), CStr(.Fields(5).Value), strSKU, False)
                                            End If
                                        Case "BETA"
                                            If blnUseWS Then
                                                If blnUseOakleaf Then
                                                   If blnUseCom Then
                                                      astrResponse(bytDist, 2) = comBetaWS.CheckStock(CStr(.Fields(2).Value), CStr(.Fields(3).Value), CStr(.Fields(4).Value), CStr(.Fields(5).Value), strSKU, True)
                                                   Else
                                                      astrResponse(bytDist, 2) = remBetaWS.CheckStock(CStr(.Fields(2).Value), CStr(.Fields(3).Value), CStr(.Fields(4).Value), CStr(.Fields(5).Value), strSKU, True)
                                                   End If
                                                Else
                                                   astrResponse(bytDist, 2) = objBetaWS.CheckStock(CStr(.Fields(2).Value), CStr(.Fields(3).Value), CStr(.Fields(4).Value), CStr(.Fields(5).Value), strSKU, True)
                                                End If
                                                'strServiceURL = strServiceURL & "Beta/BetaDist.wsdl"
                                            Else
                                                astrResponse(bytDist, 2) = objBetaInv.CheckStock(CStr(.Fields(2).Value), CStr(.Fields(3).Value), CStr(.Fields(4).Value), CStr(.Fields(5).Value), strSKU, False)
                                            End If
                                        Case "GAMM"
                                            If blnUseWS Then
                                                If blnUseOakleaf Then
                                                   If blnUseCom Then
                                                      astrResponse(bytDist, 2) = comGammaWS.CheckStock(CStr(.Fields(2).Value), CStr(.Fields(3).Value), CStr(.Fields(4).Value), CStr(.Fields(5).Value), strSKU, True)
                                                   Else
                                                      astrResponse(bytDist, 2) = remGammaWS.CheckStock(CStr(.Fields(2).Value), CStr(.Fields(3).Value), CStr(.Fields(4).Value), CStr(.Fields(5).Value), strSKU, True)
                                                   End If
                                                Else
                                                   astrResponse(bytDist, 2) = objGammaWS.CheckStock(CStr(.Fields(2).Value), CStr(.Fields(3).Value), CStr(.Fields(4).Value), CStr(.Fields(5).Value), strSKU, True)
                                                End If
                                            Else
                                                astrResponse(bytDist, 2) = objGammaInv.CheckStock(CStr(.Fields(2).Value), CStr(.Fields(3).Value), CStr(.Fields(4).Value), CStr(.Fields(5).Value), strSKU, False)
                                            End If
                                    End Select
                                End If
                                If Err.Number <> 0 And astrResponse(bytDist, 1) <> "NONE" Then
                                    astrResponse(bytDist, 1) = "NONE"
                                    astrResponse(bytDist, 2) = "ERROR: " & Err.Description
                                End If
                                .Close()
                            End With
                            .MoveNext()
                        Loop
                        'ToDo: Calculate the best price, including discounts and allowances
                        'Temporarily, choose the distributor with the largest inventory
                        If bytDist > 0 Then
                            For bytCtr = 1 To bytDist
                                If blnUseWS Then
                                    With docDist
                                        'Load the document
                                        .loadXML(astrResponse(bytCtr, 2))
                                        If .parseError.errorCode = 0 Then
                                            'Get quantity
                                            lstDist = .getElementsByTagName("QuantityInStock")
                                            If lstDist.length > 0 Then
                                                nodDist = lstDist(0)
                                                astrResponse(bytCtr, 0) = nodDist.text
                                            Else
                                                'Error
                                            End If
                                        Else
                                            'Parse error
                                        End If
                                    End With
                                Else
                                    If InStr(astrResponse(bytCtr, 2), "InStock") Then
                                        strQuan = astrResponse(bytCtr, 2)
                                        strQuan = Mid(strQuan, InStrRev(strQuan, "=") + 1)
                                        astrResponse(bytCtr, 0) = strQuan
                                    Else
                                        'error
                                    End If
                                End If
                            Next bytCtr
                            strQuan = "0"
                            If bytDist > 1 Then
                                For bytCtr = 1 To bytDist
                                    'Get the largest quantity
                                    If Val(astrResponse(bytCtr, 0)) > Val(strQuan) Then
                                        strQuan = astrResponse(bytCtr, 0)
                                    End If
                                Next bytCtr
                                For bytCtr = 1 To bytDist
                                    'Find that distributor
                                    If Val(astrResponse(bytCtr, 0)) = CDbl(strQuan) Then
                                        If Val(strQuan) > 0 Then
                                            GetDistInventory = astrResponse(bytCtr, 1)
                                        Else
                                            GetDistInventory = "No"
                                        End If
                                    End If
                                Next bytCtr
                            Else
                                If Val(astrResponse(bytDist, 0)) > 0 Then
                                    GetDistInventory = astrResponse(bytDist, 1)
                                Else
                                    GetDistInventory = "No"
                                End If
                            End If
                        Else
                            'No distributor records found
                            GetDistInventory = "No"
                        End If
                    End If
                End With
            End If
        Else
            GetDistInventory = "No"
        End If

        'Cleanup
        With rstProd
            If .State = ADODB.ObjectStateEnum.adStateOpen Then
                .Close()
            End If
        End With
        With rstBrand
            If .State = ADODB.ObjectStateEnum.adStateOpen Then
                .Close()
            End If
        End With
        With rstDist
            If .State = ADODB.ObjectStateEnum.adStateOpen Then
                .Close()
            End If
        End With
        With cnnProd
            If .State = ADODB.ObjectStateEnum.adStateOpen Then
                .Close()
            End If
        End With
    End Function

    Public Function ShipItems(ByVal strCustServer As String, ByVal strCustUser As String, ByVal strCustPwd As String, ByVal strProdServer As String, ByVal strProdUser As String, ByVal strProdPwd As String, ByVal strNetServer As String, ByVal strNetUser As String, ByVal strNetPwd As String, ByVal strNetIP As String, ByVal lngOrderID As Integer, ByVal strCardNumber As String, ByVal blnGetUPSCharge As Boolean, ByVal blnUseWS As Boolean, ByVal blnUseOakLeaf As Boolean, ByVal blnUseCom As Boolean) As String

        'Ship in-stock items to customer, change committed to shipped
        'Mark line items not shipped as backordered
        'Prepare invoice(s) to include with shipment(s)
        'Charge card (remove hold for items shipped)

        Dim cnnCust As New ADODB.Connection()
        Dim cnnProd As New ADODB.Connection()
        Dim cnnInvoice As New ADODB.Connection()
        Dim cnnPurchOrd As New ADODB.Connection()
        Dim rstCust As New ADODB.Recordset()
        Dim rstShipTo As New ADODB.Recordset()
        Dim rstOrder As New ADODB.Recordset()
        Dim rstItems As New ADODB.Recordset()
        Dim rstProd As New ADODB.Recordset()
        Dim rstInvoice As New ADODB.Recordset()
        Dim rstTemp As New ADODB.Recordset()

        Dim OmegaBank As New OmegaBank.clsOmegaBank()
        'Dim objOmegaBank As Object
        'Dim objOmegaBank As New MSSOAPLib.SoapClient()
        Dim objOmegaBank As New OmegaWS.OmegaBank()
        Dim remOmegaBank As New OmegaWSRem.OmegaBank()
        Dim comOmegaBank As New OmegaWSCom.OmegaBank()

        Dim strCustConn As String
        Dim strProdConn As String
        Dim strSQL As String
        Dim blnAllInStock As Boolean
        Dim lngReccnt As Integer
        'Dimensions are arbitrary
        Dim acurItemsTotal(10) As Decimal
        Dim acurSalesTax(10) As Decimal
        Dim acurFreight(10) As Decimal
        Dim astrTrackingID(10) As String
        Dim astrShipTypeID(10) As String
        Dim acurOrderTotal(10) As Decimal
        'Added dimension for Visual Basic .NET
        Dim alngPurchInvID(10, 3) As Integer
        Dim curOrderTotal As Decimal
        Dim bytOurInvNum As Byte
        Dim bytInv As Byte
        Dim blnUPSAndTruck As Boolean
        Dim lngTransactID As Integer
        Dim strCharge As String
        Dim strStatus As String
        Dim strMsg As String
        Dim strTRID As String
        Dim bytNumInvoices As Byte
        Dim strPartShip As String
        Dim strErrMsg As String
        Dim intSuspend As Short
        Dim lngPurchID As Integer
        Dim intCol As Short
        Dim strXML As String
        Dim intItems As Short
        Dim bytItem As Byte
        Dim strDistID As String
        Dim strDistList As String
        Dim lngInvoiceID As Integer
        Dim strServer As String
        Dim strURL As String

        'Initial values
        blnAllInStock = True
        blnUPSAndTruck = False
        strPartShip = "0"

        On Error Resume Next

        'Initial connections
        strCustConn = "Provider=SQLOLEDB;Data Source=" & strCustServer & ";Initial Catalog=OCE_Cust;UID=" & strCustUser & ";PWD=" & strCustPwd
        cnnCust.Open(strCustConn)

        strProdConn = "Provider=SQLOLEDB;Data Source=" & strProdServer & ";Initial Catalog=OCE_Prod;UID=" & strProdUser & ";PWD=" & strProdPwd
        cnnProd.Open(strProdConn)

        If Err.Number <> 0 Then
            strErrMsg = "Can't open connections"
            GoTo ExitShipItems
        End If

        With cnnCust
            'Get the full Orders record
            strSQL = "SELECT * FROM Orders WHERE OrderID = " & lngOrderID
            rstOrder = .Execute(strSQL, , ADODB.CommandTypeEnum.adCmdText)
            If rstOrder.EOF Then
                strErrMsg = "Order not found"
                GoTo ExitShipItems
            Else
                If IsDBNull(rstOrder.Fields("CCTransactionID").Value) Then
                    strErrMsg = "No transaction ID"
                    GoTo ExitShipItems
                Else
                    lngTransactID = CInt(rstOrder.Fields("CCTransactionID").Value)
                    'Get the LineItems records
                    strSQL = "SELECT * FROM LineItems WHERE OrderID = " & CStr(lngOrderID)
                    rstItems = .Execute(strSQL, , ADODB.CommandTypeEnum.adCmdText)
                    If rstItems.EOF Then
                        strErrMsg = "No line items found"
                        GoTo ExitShipItems
                    Else
                        'Get the full Customers record (to print invoice)
                        strSQL = "SELECT * FROM Customers WHERE CustID = " & CStr(rstOrder.Fields("CustID").Value)
                        rstCust = .Execute(strSQL, , ADODB.CommandTypeEnum.adCmdText)
                        If rstCust.EOF Then
                            strErrMsg = "No customer record found"
                            GoTo ExitShipItems
                        End If
                        strSQL = "SELECT * FROM ShipAddresses WHERE CustID = " & CStr(rstOrder.Fields("CustID").Value) & " AND ShipToID = " & CStr(rstOrder.Fields("ShipToID").Value)
                        rstShipTo = .Execute(strSQL, , ADODB.CommandTypeEnum.adCmdText)
                        If rstShipTo.EOF Then
                            strErrMsg = "No customer shipping address record found"
                            GoTo ExitShipItems
                        End If
                    End If
                End If
            End If
        End With

        'Field names used below for readability
        bytNumInvoices = 0
        bytOurInvNum = 0
        With rstItems
            Do Until .EOF
                'Update line items records and inventory record
                strStatus = ""
                strSQL = "SELECT ShipWeight, Cost FROM Products WHERE SKU = '" & CStr(.Fields("SKU").Value) & "'"
                rstProd = cnnProd.Execute(strSQL, , ADODB.CommandTypeEnum.adCmdText)
                If rstProd.EOF Then
                    strErrMsg = "No product record found"
                    GoTo ExitShipItems
                End If

                If CByte(.Fields("StatusID").Value) = 31 And Not CBool(.Fields("Outsourced").Value) Then
                    'Order to Warehouse (Commit); change status to 41 - Item shipped
                    strSQL = "UPDATE LineItems SET StatusID = 41 " & "WHERE OrderID = " & CStr(lngOrderID) & " AND ItemID = " & CStr(.Fields("ItemID").Value)
                    cnnCust.Execute(strSQL, lngReccnt, ADODB.CommandTypeEnum.adCmdText)
                    If CInt(lngReccnt) = 1 Then
                        strStatus = "41"
                        'Move committed inventory to shipped status
                        strSQL = "UPDATE Products SET CommittedNow = CommittedNow - " & CStr(.Fields("Quantity").Value) & ", ShippedInPeriod = ShippedInPeriod + " & CStr(.Fields("Quantity").Value) & " WHERE SKU = '" & CStr(.Fields("SKU").Value) & "'"
                        cnnProd.Execute(strSQL, lngReccnt, ADODB.CommandTypeEnum.adCmdText)

                        'One invoice for all items in stock
                        If bytOurInvNum = 0 Then
                            bytNumInvoices = bytNumInvoices + 1
                            bytOurInvNum = bytNumInvoices
                        End If
                    Else
                        strErrMsg = "Committed to ship update failed"
                        GoTo ExitShipItems
                    End If
                Else
                    If CBool(.Fields("Outsourced").Value) Then
                        'Todo: This needs a fixup in cmdIssueHolds for individual line item status
                        'Change status to 42 - Shipped by Distributor (separate invoice)
                        strSQL = "UPDATE LineItems SET StatusID = 42 "
                        strStatus = "42"
                        If InStr(strDistList, CStr(.Fields("OrderFrom").Value)) = 0 Then
                            'Another invoice required
                            bytNumInvoices = bytNumInvoices + 1
                        End If
                    Else
                        'Change status to 40 - Item Backordered
                        blnAllInStock = False
                        strPartShip = "1"
                        strSQL = "UPDATE LineItems SET StatusID = 40 "
                        strStatus = "40"
                    End If
                    strSQL = strSQL & "WHERE OrderID = " & CStr(lngOrderID) & " AND ItemID = " & CStr(.Fields("ItemID").Value)
                    cnnCust.Execute(strSQL, lngReccnt, ADODB.CommandTypeEnum.adCmdText)
                    If CInt(lngReccnt) <> 1 Then
                        strErrMsg = "Update line item status failed"
                        GoTo ExitShipItems
                    End If
                End If

                If strStatus = "41" Or strStatus = "42" Then
                    'Get current items total
                    acurItemsTotal(bytNumInvoices) = acurItemsTotal(bytNumInvoices) + (CDec(CShort(.Fields("Quantity").Value) * CDec(.Fields("UnitPrice").Value)))

                    'Get sales tax
                    If CBool(rstOrder.Fields("SalesTaxApplies").Value) Then
                        acurSalesTax(bytNumInvoices) = CDec(System.Math.Round(CDec(0.06) * acurItemsTotal(bytNumInvoices), 2))
                    Else
                        acurSalesTax(bytNumInvoices) = 0
                    End If

                    'Get freight cost
                    acurFreight(bytNumInvoices) = acurFreight(bytNumInvoices) + GetItemFreight(CStr(rstCust.Fields("ZIPCode").Value), CSng(rstProd.Fields("ShipWeight").Value), blnGetUPSCharge)

                    'Set ship type and tracking IDs
                    Randomize()
                    If CShort(rstProd.Fields("ShipWeight").Value) > 50 Then
                        'Truck
                        astrShipTypeID(bytNumInvoices) = "33"
                        astrTrackingID(bytNumInvoices) = astrTrackingID(bytNumInvoices) & CStr(CInt(10000000 * Rnd())) & " "
                    Else
                        astrShipTypeID(bytNumInvoices) = "11"
                        astrTrackingID(bytNumInvoices) = astrTrackingID(bytNumInvoices) & "1Z" & CStr(CInt(10000000 * Rnd())) & " "
                    End If
                End If

                If strStatus = "42" Then
                    'Outsourced
                    If lngPurchID = 0 Or (lngPurchID > 0 And InStr(strDistList, CStr(.Fields("OrderFrom").Value)) = 0) Then
                        'Generate a purchase order to the distributor (transaction)
                        'ToDo: If more than one order is outsourced, rerun an inventory
                        '      test at the same distributor to consolidate the shipment
                        cnnPurchOrd.Open(strProdConn)
                        cnnPurchOrd.BeginTrans()
                        strDistID = CStr(.Fields("OrderFrom").Value)
                        strSQL = "INSERT PurchaseOrders(OrderDate, DistID, ShipToCustomer, ReferenceID, " & "RequiredShipDate, ShipName, ShipAddress, ShipCity, ShipState, " & "ShipZIPCode, ShipPhone, ShipByID, PartialShipOK) VALUES('" & CStr(Now) & "', '" & strDistID & "', 1, " & CStr(lngOrderID) & ", '" & CStr(Now) & "', '" & CStr(rstShipTo.Fields(2).Value) & "', '" & CStr(rstShipTo.Fields(3).Value) & "', '" & CStr(rstShipTo.Fields(4).Value) & "', '" & CStr(rstShipTo.Fields(5).Value) & "', '" & CStr(rstShipTo.Fields(6).Value) & "', '" & CStr(rstCust.Fields("Phone").Value) & "', " & astrShipTypeID(bytNumInvoices) & ", 0)"
                        cnnPurchOrd.Execute(strSQL, lngReccnt, ADODB.CommandTypeEnum.adCmdText)
                        If CInt(lngReccnt) = 0 Then
                            cnnPurchOrd.RollbackTrans()
                        Else
                            'Get the PO number
                            strSQL = "SELECT @@identity"
                            rstTemp = cnnPurchOrd.Execute(strSQL, , ADODB.CommandTypeEnum.adCmdText)
                            If .EOF Then
                                cnnPurchOrd.RollbackTrans()
                                'Mark the line item bad
                                strSQL = "UPDATE LineItems SET StatusID = 99 "
                                strStatus = "99"
                            Else
                                'Add the line item (most orders have only one outsourced item)
                                lngPurchID = CInt(rstTemp.Fields(0).Value)
                                alngPurchInvID(bytNumInvoices, 1) = lngPurchID
                                strSQL = "INSERT POLineItems VALUES(" & lngPurchID & ", 1, " & CStr(.Fields("Quantity").Value) & ", '" & CStr(.Fields("SKU").Value) & "', " & CStr(rstProd.Fields("Cost").Value) & ", 0, 0, 0, 0, 32)"
                                cnnPurchOrd.Execute(strSQL, lngReccnt, ADODB.CommandTypeEnum.adCmdText)

                                If CInt(lngReccnt) = 0 Then
                                    cnnPurchOrd.RollbackTrans()
                                    strSQL = "UPDATE LineItems SET StatusID = 99 "
                                    strStatus = "99"
                                Else
                                    cnnPurchOrd.CommitTrans()
                                    strSQL = "UPDATE LineItems SET StatusID = 42 "
                                    strStatus = "42"
                                    'Distibutors with POs for this order
                                    strDistList = strDistList & CStr(.Fields("OrderFrom").Value) & " " & CStr(bytNumInvoices) & " "
                                End If
                            End If
                            rstTemp.Close()
                        End If
                        cnnPurchOrd.Close()
                    ElseIf InStr(strDistList, CStr(.Fields("OrderFrom").Value)) > 0 Then
                        'Add a line item for multiple outsourced items to the same distributor
                        'This rarely occurs and isn't in the original transaction
                        strSQL = "SELECT PurchID FROM PurchaseOrders " & "WHERE ReferenceID = " & CStr(lngOrderID) & " AND DistID = '" & CStr(.Fields("OrderFrom").Value) & "'"
                        rstTemp = cnnProd.Execute(strSQL, lngReccnt, ADODB.CommandTypeEnum.adCmdText)
                        If Not rstTemp.EOF Then
                            lngPurchID = CInt(rstTemp.Fields(0).Value)
                            strSQL = "SELECT COUNT(PurchID) FROM POLineItems WHERE PurchID = " & CStr(lngPurchID)
                            rstTemp = cnnProd.Execute(strSQL, , ADODB.CommandTypeEnum.adCmdText)
                            If Not rstTemp.EOF Then
                                bytItem = CByte(rstTemp.Fields(0).Value)
                                bytItem = bytItem + 1
                            End If
                            rstTemp.Close()
                        End If
                        If lngPurchID = 0 Or bytItem = 0 Then
                            strSQL = "UPDATE LineItems SET StatusID = 99 "
                        Else
                            strSQL = "INSERT POLineItems VALUES(" & lngPurchID & ", " & CStr(bytItem) & ", " & CStr(.Fields("Quantity").Value) & ", '" & CStr(.Fields("SKU").Value) & "', " & CStr(rstProd.Fields("Cost").Value) & ", 0, 0, 0, 0, 32)"
                            cnnProd.Execute(strSQL, lngReccnt, ADODB.CommandTypeEnum.adCmdText)

                            If CInt(lngReccnt) = 0 Then
                                strSQL = "UPDATE LineItems SET StatusID = 99 "
                                strStatus = "99"
                            Else
                                strSQL = "UPDATE LineItems SET StatusID = 42 "
                                strStatus = "42"
                            End If
                        End If
                    End If
                End If
                .MoveNext()
            Loop
            .Close()
        End With

        'Calculate total charge for shipment, including freight and sales tax (if applicable)
        curOrderTotal = 0
        For bytInv = 1 To bytNumInvoices
            curOrderTotal = curOrderTotal + CDec(acurItemsTotal(bytInv) + acurFreight(bytInv) + CDec(System.Math.Round(acurSalesTax(bytInv), 2)))
        Next bytInv

        'Remove/Reduce hold, charge card
        If blnUseWS Then
            If blnUseOakLeaf Then
               'Use OakLeaf's remote Web services
               strServer = "OAKLEAF-MS7"
               If blnUseCom Then
                  'Use the COM-based component's WSDL file
                  strCharge = comOmegaBank.ChargeOrCredit(strServer, strNetUser, strNetPwd, 151203, lngOrderID, strCardNumber, lngTransactID, CSng(curOrderTotal), blnAllInStock, False, blnUseWS)
               Else
                  strCharge = remOmegaBank.ChargeOrCredit(strServer, strNetUser, strNetPwd, 151203, lngOrderID, strCardNumber, lngTransactID, curOrderTotal, blnAllInStock, False, blnUseWS)
               End If
            Else
                strServer = strNetServer
                strCharge = objOmegaBank.ChargeOrCredit(strServer, strNetUser, strNetPwd, 151203, lngOrderID, strCardNumber, lngTransactID, CSng(curOrderTotal), blnAllInStock, False, blnUseWS)
            End If
        Else
            strCharge = OmegaBank.ChargeOrCredit(strNetServer, strNetUser, strNetPwd, 151203, lngOrderID, strCardNumber, lngTransactID, CSng(curOrderTotal), blnAllInStock, False, blnUseWS)
        End If
        If InStr(UCase(strCharge), "ERROR") Then
            ShipItems = strCharge
            GoTo ExitShipItems
        ElseIf Err.Number <> 0 Then
            ShipItems = "ERROR: " & Err.Description
            GoTo ExitShipItems
        End If

        'Update the order status
        If InStr(strCharge, "(") Then
            strStatus = Mid(strCharge, InStr(strCharge, "(") + 1)
            If InStr(strStatus, ")") Then
                strStatus = Left(strStatus, InStr(strStatus, ")") - 1)
                strCharge = Mid(strCharge, InStr(strCharge, " ") + 1)
                If InStr(strCharge, " TRID ") Then
                    strTRID = Mid(strCharge, InStr(strCharge, " TRID ") + 6)
                    strTRID = Left(strTRID, InStr(strTRID, " ") - 1)
                Else
                    strErrMsg = "Invalid OmegaBank status value"
                    GoTo ExitShipItems
                End If
            Else
                strErrMsg = "Invalid OmegaBank status value"
                GoTo ExitShipItems
            End If
        Else
            strErrMsg = "Invalid OmegaBank status value"
            GoTo ExitShipItems
        End If
        lngReccnt = 0

        If strStatus = "32" Then
            If blnAllInStock Then
                strStatus = "59" 'Shipment Complete
                strMsg = "Shipment Complete"
            Else
                'Todo: Check for prior partial shipments
                strStatus = "51"
                strMsg = "Partial Shipment 1"
            End If
            strSQL = "UPDATE Orders SET StatusID = " & strStatus & ", " & "LastStatusUpdate = '" & CStr(Now) & "', LastStatusMessage = '" & strMsg & "', CCTransactionID = " & strTRID & " WHERE OrderID = " & CStr(lngOrderID)
            cnnCust.Execute(strSQL, lngReccnt, ADODB.CommandTypeEnum.adCmdText)
            If CInt(lngReccnt) = 0 Then
                strErrMsg = "Couldn't update record for order " & CStr(lngOrderID)
                GoTo ExitShipItems
            End If

            If bytNumInvoices > 0 Then
                'Transaction starts here
                With cnnInvoice
                    .Open(strCustConn)
                    .CommandTimeout = 10
                    .BeginTrans()
                End With

                'Generate invoice(s)
                With rstOrder
                    For bytInv = 1 To bytNumInvoices
                        If astrShipTypeID(bytInv) = "" Then
                            'Safety net for bytNumInvoices too large (shouldn't occur)
                            Exit For
                        End If
                        'Insert the invoice(s)
                        strSQL = "INSERT Invoices(OrderID, CustID, OrderDate, ShipDate, ShipTypeID, TrackingID, " & "ShippingCharge, SalesTax, PartialShipment, CardDigits, ShipToID, StatusID, CCTransactionID) " & "VALUES(" & CStr(.Fields("OrderID").Value) & ", " & CStr(.Fields("CustID").Value) & ", '" & CStr(.Fields("OrderDate").Value) & "', '" & CStr(Now) & "', " & astrShipTypeID(bytInv) & ", '" & Trim(astrTrackingID(bytInv)) & "', " & CStr(acurFreight(bytInv)) & ", " & CStr(acurSalesTax(bytInv)) & ", " & strPartShip & ", '" & Right(strCardNumber, 4) & "', " & CStr(.Fields("ShipToID").Value) & ", " & strStatus & ", " & strTRID & ")"
                        cnnInvoice.Execute(strSQL, lngReccnt, ADODB.CommandTypeEnum.adCmdText)

                        If CInt(lngReccnt) = 1 Then
                            'Get the proposed invoice number
                            strSQL = "SELECT @@identity"
                            rstInvoice = cnnInvoice.Execute(strSQL, lngReccnt, ADODB.CommandTypeEnum.adCmdText)
                            If rstInvoice.EOF Then
                                cnnInvoice.RollbackTrans()
                                strErrMsg = "Couldn't obtain InvoiceID for invoice " & CStr(bytNumInvoices)
                                GoTo ExitShipItems
                            Else
                                lngInvoiceID = CInt(rstInvoice.Fields(0).Value)
                                alngPurchInvID(bytInv, 2) = lngInvoiceID
                                strSQL = "INSERT OrdersInvoices VALUES(" & CStr(rstOrder.Fields("OrderID").Value) & ", " & CStr(lngInvoiceID) & ")"
                                cnnInvoice.Execute(strSQL, lngReccnt, ADODB.CommandTypeEnum.adCmdText)
                                If CInt(lngReccnt) <> 1 Then
                                    cnnInvoice.RollbackTrans()
                                    strErrMsg = "Couldn't add OrdersInvoices record for invoice " & CStr(bytNumInvoices)
                                    GoTo ExitShipItems
                                End If
                                rstInvoice.Close()
                            End If
                        Else
                            cnnInvoice.RollbackTrans()
                            strErrMsg = "Couldn't add invoice " & CStr(bytNumInvoices)
                            GoTo ExitShipItems
                        End If
                    Next bytInv
                End With
                'Commit all invoices at once
                cnnInvoice.CommitTrans()

                'The following must be done after committing the transaction
                'to avoid a major-scale SQL Server performance hit
                For bytInv = 1 To bytNumInvoices
                    If alngPurchInvID(bytInv, 1) > 0 Then
                        'Serialize the invoice
                        lngPurchID = alngPurchInvID(bytInv, 1)
                        lngInvoiceID = alngPurchInvID(bytInv, 2)
                        strSQL = "SELECT * FROM Invoices WHERE InvoiceID = " & lngInvoiceID
                        rstInvoice = cnnCust.Execute(strSQL, , ADODB.CommandTypeEnum.adCmdText)

                        strXML = SerializeCustInvoice(lngInvoiceID, lngOrderID, cnnCust, cnnProd, rstInvoice, rstCust, rstShipTo, strDistID)

                        If InStr(strXML, "Error:") = 0 Then
                            'Text might contain "'", fix occurrences
                            strXML = Replace(strXML, "'", "''")
                            'Add the serialized invoice to the purchase order to preserve it
                            strSQL = "UPDATE PurchaseOrders SET CustInvoice = '" & strXML & "' WHERE PurchID = " & CStr(lngPurchID)
                            cnnProd.Execute(strSQL, lngReccnt, ADODB.CommandTypeEnum.adCmdText)
                            If CInt(lngReccnt) = 1 Then
                                'Format the order as XML and send it to the distributor
                                strXML = ""
                                strXML = SendPurchaseOrder(strProdServer, strProdUser, strProdPwd, lngPurchID, blnUseWS, blnUseOakLeaf, blnUseCom)
                                If Len(strXML) < 100 Then
                                    'Error
                                End If
                            Else
                                'Error
                            End If
                        Else
                            'Error
                        End If
                    End If
                Next bytInv
            End If
        Else
            strErrMsg = "Error: Order status <> 32"
        End If

ExitShipItems:
        Dim UpdateOrder As New clsUpdateOrder()
        If Len(strErrMsg) Then
            'Todo: Should rollback credit-card charge
            'Place order and line items in suspend state
            intSuspend = UpdateOrder.UpdateOrderStatus(strCustServer, strCustUser, strCustPwd, lngOrderID, 99, CStr(lngOrderID) & " " & strErrMsg, 0)
            ShipItems = "Error: Can't generate invoice " & strErrMsg & " (transaction rolled back)"
        ElseIf bytNumInvoices > 0 Then
            If bytNumInvoices > 1 Then
                ShipItems = CStr(bytNumInvoices) & " invoices "
            Else
                ShipItems = "Invoice "
            End If
            ShipItems = ShipItems & " issued for " & VB6.Format(curOrderTotal, "$#,##0.00") & "; card charged"
            If blnAllInStock Then
                ShipItems = ShipItems & " (order complete)"
            Else
                ShipItems = ShipItems & " (partial shipment)"
            End If
        End If

        'Cleanup
        With rstCust
            If .State = ADODB.ObjectStateEnum.adStateOpen Then
                .Close()
            End If
        End With
        With rstOrder
            If .State = ADODB.ObjectStateEnum.adStateOpen Then
                .Close()
            End If
        End With
        With rstItems
            If .State = ADODB.ObjectStateEnum.adStateOpen Then
                .Close()
            End If
        End With
        With rstProd
            If .State = ADODB.ObjectStateEnum.adStateOpen Then
                .Close()
            End If
        End With
        With rstShipTo
            If .State = ADODB.ObjectStateEnum.adStateOpen Then
                .Close()
            End If
        End With
        With rstTemp
            If .State = ADODB.ObjectStateEnum.adStateOpen Then
                .Close()
            End If
        End With
        With rstInvoice
            If .State = ADODB.ObjectStateEnum.adStateOpen Then
                .Close()
            End If
        End With
        With cnnCust
            If .State = ADODB.ObjectStateEnum.adStateOpen Then
                .Close()
            End If
        End With
        With cnnProd
            If .State = ADODB.ObjectStateEnum.adStateOpen Then
                .Close()
            End If
        End With
        With cnnInvoice
            If .State = ADODB.ObjectStateEnum.adStateOpen Then
                .Close()
            End If
        End With
        With cnnPurchOrd
            If .State = ADODB.ObjectStateEnum.adStateOpen Then
                .Close()
            End If
        End With
    End Function

    Private Function GetItemFreight(ByVal strZipCode As String, ByVal sngWeight As Single, ByVal blnGetUPSCharge As Boolean) As Decimal

        'Get freight charge for each item shipped
        Dim UPSCharges As New clsShipCost()
        Dim strUPSResult As String

        On Error Resume Next

        'Fix ZIP Code
        If InStr(strZipCode, "-") Then
            strZipCode = Left(strZipCode, InStr(strZipCode, "-") - 1)
        End If

        GetItemFreight = 0
        If sngWeight > 50 Or Not blnGetUPSCharge Then
            '$0.50 per pound
            GetItemFreight = CDec(0.5 * sngWeight)
        Else
            strUPSResult = UPSCharges.GetUpsCost("GND", strZipCode, CShort(sngWeight) + 1)
            If Val(strUPSResult) > 0 Then
                GetItemFreight = CDec(Val(strUPSResult))
            Else
                'Error
                GetItemFreight = -1
            End If
        End If
    End Function

    Private Function SerializeCustInvoice(ByVal lngInvoiceID As Integer, ByVal lngOrderID As Integer, ByRef cnnCust As ADODB.Connection, ByRef cnnProd As ADODB.Connection, ByRef rstInvoice As ADODB.Recordset, ByRef rstCust As ADODB.Recordset, ByRef rstShipTo As ADODB.Recordset, ByRef strDistID As String) As String

        'Distributors require customer invoices (packing lists) in a standardized XML
        'format for printing and enclosure in shipment
        'Implemented as Private Function to reduce length of ShipItems function

        Dim rstItems As New ADODB.Recordset()
        Dim rstProd As New ADODB.Recordset()

        Dim strXML As String
        Dim intCol As Short
        Dim strSQL As String

        On Error Resume Next

        With rstInvoice
            If .EOF Then
                strXML = "Error: Can't find invoice " & lngInvoiceID
            Else
                'Serialize the invoice, starting with invoice header
                strXML = "   <CustomerInvoice>" & vbCrLf & Space(6) & "<Header>" & vbCrLf
                For intCol = 0 To CShort(.Fields.Count) - 2
                    strXML = strXML & Space(9) & "<" & CStr(.Fields(intCol).Name) & ">" & CStr(.Fields(intCol).Value) & "</" & CStr(.Fields(intCol).Name) & ">" & vbCrLf
                Next intCol
                strXML = strXML & Space(6) & "</Header>" & vbCrLf & Space(6) & "<BillingAddr>" & vbCrLf

                'Add billing address
                With rstCust
                    'Combine first and last name
                    strXML = strXML & Space(9) & "<Name>" & CStr(.Fields(1).Value) & " " & CStr(.Fields(2).Value) & "</Name>" & vbCrLf

                    For intCol = 3 To 6
                        strXML = strXML & Space(9) & "<" & CStr(.Fields(intCol).Name) & ">" & CStr(.Fields(intCol).Value) & "</" & CStr(.Fields(intCol).Name) & ">" & vbCrLf
                    Next intCol
                End With
                strXML = strXML & Space(6) & "</BillingAddr>" & vbCrLf & Space(6) & "<ShippingAddr>" & vbCrLf

                'Add shipping address
                With rstShipTo
                    For intCol = 2 To CShort(.Fields.Count) - 1
                        strXML = strXML & Space(9) & "<Ship" & CStr(.Fields(intCol).Name) & ">" & CStr(.Fields(intCol).Value) & "</Ship" & CStr(.Fields(intCol).Name) & ">" & vbCrLf
                    Next intCol
                End With
                strXML = strXML & Space(6) & "</ShippingAddr>" & vbCrLf & Space(6) & "<LineItems>" & vbCrLf

                'Add outsourced line items
                strSQL = "SELECT * FROM LineItems WHERE OrderID = " & lngOrderID
                rstItems = cnnCust.Execute(strSQL, , ADODB.CommandTypeEnum.adCmdText)
                With rstItems
                    Do Until .EOF
                        If CBool(.Fields("Outsourced").Value) Then
                            If CStr(.Fields("OrderFrom").Value) = strDistID Then
                                'Item is outsourced to this distributor, get product info
                                strSQL = "SELECT BrandID, Model, Description FROM Products " & "WHERE SKU = '" & CStr(.Fields(3).Value) & "'"
                                rstProd = cnnProd.Execute(strSQL, , ADODB.CommandTypeEnum.adCmdText)
                                If rstProd.EOF Then
                                    strXML = "Error: Can't find product record"
                                Else
                                    strXML = strXML & Space(9) & "<Item>" & vbCrLf
                                    'Add ItemID, Quantity, SKU
                                    For intCol = 1 To 3
                                        strXML = strXML & Space(12) & "<" & CStr(.Fields(intCol).Name) & ">" & CStr(.Fields(intCol).Value) & "</" & CStr(.Fields(intCol).Name) & ">" & vbCrLf
                                    Next intCol

                                    'Add BrandID, Model, Description
                                    For intCol = 0 To 2
                                        strXML = strXML & Space(12) & "<" & CStr(rstProd.Fields(intCol).Name) & ">" & CStr(rstProd.Fields(intCol).Value) & "</" & CStr(rstProd.Fields(intCol).Name) & ">" & vbCrLf
                                    Next intCol

                                    'Add UnitPrice, Discount, etc.
                                    For intCol = 5 To CShort(.Fields.Count) - 4
                                        strXML = strXML & Space(12) & "<" & CStr(.Fields(intCol).Name) & ">" & CStr(.Fields(intCol).Value) & "</" & CStr(.Fields(intCol).Name) & ">" & vbCrLf
                                    Next intCol
                                    strXML = strXML & Space(9) & "</Item>" & vbCrLf
                                End If
                            End If
                        End If
                        .MoveNext()
                    Loop
                End With
                If InStr(strXML, "Error:") = 0 Then
                    '& appears occasionally in addresses
                    strXML = Replace(strXML, "&", "and")
                    strXML = strXML & Space(6) & "</LineItems> " & vbCrLf & "   </CustomerInvoice>"
                End If
            End If
        End With
        SerializeCustInvoice = strXML
    End Function


    Private Function SendPurchaseOrder(ByVal strProdServer As String, ByVal strProdUser As String, ByVal strProdPwd As String, ByVal lngPurchID As Integer, ByVal blnUseWS As Boolean, ByVal blnUseOakLeaf As Boolean, ByVal blnUseCom As Boolean) As String

        'Transmit purchase orders for outsourced items or to replenish inventory
        'All distributors require a standard XML format, with or without
        '<CustomerInvoice> elements
        Dim cnnOrder As New ADODB.Connection()
        Dim rstOrder As New ADODB.Recordset()
        Dim rstItems As New ADODB.Recordset()
        Dim rstDist As New ADODB.Recordset()
        Dim docOrder As New MSXML2.DOMDocument40()

        Dim objAlphaWS As New AlphaWS.AlphaDist()
        Dim remAlphaWS As New AlphaWSRem.AlphaDist()
        Dim comAlphaWS As New AlphaWSCom.AlphaDist()
        Dim objBetaWS As New BetaWS.BetaDist()
        Dim remBetaWS As New BetaWSRem.BetaDist()
        Dim comBetaWS As New BetaWSCom.BetaDist()
        Dim objGammaWS As New GammaWS.GammaDist()
        Dim remGammaWS As New GammaWSRem.GammaDist()
        Dim comGammaWS As New GammaWSCom.GammaDist()

        Dim strProdConn As String
        Dim strSQL As String
        Dim intCol As Short
        Dim strXML As String
        Dim strServer As String
        Dim strDatabase As String
        Dim strUserName As String
        Dim strPassword As String
        Dim strOrderURL As String
        Dim strServiceURL As String
        Dim strResponse As String

        On Error Resume Next

        'Connect to the production database
        strProdConn = "Provider=SQLOLEDB;Data Source=" & strProdServer & ";Initial Catalog=OCE_Prod;UID=" & strProdUser & ";PWD=" & strProdPwd
        cnnOrder.Open(strProdConn)

        With cnnOrder
            'Get the purchase order
            strSQL = "SELECT * FROM PurchaseOrders WHERE PurchID = " & CStr(lngPurchID)
            rstOrder = .Execute(strSQL, , ADODB.CommandTypeEnum.adCmdText)
            If rstOrder.EOF Then
                SendPurchaseOrder = "Error: Can't find PO# " & CStr(lngPurchID)
            Else
                'Get the distributor connection data
                strSQL = "SELECT ServerName, [Database], UserName, Password, OrderWS " & "FROM Distributors WHERE DistID = '" & CStr(rstOrder.Fields(2).Value) & "'"
                rstDist = .Execute(strSQL, , ADODB.CommandTypeEnum.adCmdText)
                If rstDist.EOF Then
                    SendPurchaseOrder = "Error: Can't find distributor code " & CStr(rstOrder.Fields(2).Value)
                Else
                    With rstDist
                        strServer = CStr(.Fields(0).Value)
                        strDatabase = CStr(.Fields(1).Value)
                        strUserName = CStr(.Fields(2).Value)
                        strPassword = CStr(.Fields(3).Value)
                        strOrderURL = CStr(.Fields(4).Value)
                    End With

                    'Get the purchase order line items
                    strSQL = "SELECT * FROM POLineItems WHERE PurchID = " & CStr(lngPurchID)
                    rstItems = .Execute(strSQL, , ADODB.CommandTypeEnum.adCmdText)
                    If rstItems.EOF Then
                        SendPurchaseOrder = "Error: Can't find line items for PO# " & CStr(lngPurchID)
                    Else
                        With rstOrder
                            strXML = "<PurchaseOrder>" & vbCrLf & "   <Header>" & vbCrLf
                            For intCol = 0 To CShort(.Fields.Count) - 2
                                If intCol < 2 Or intCol = 3 Or intCol = 5 Or intCol > 10 Then
                                    strXML = strXML & Space(6) & "<" & CStr(.Fields(intCol).Name) & ">"
                                    If intCol = 5 Then
                                        'Remove the time
                                        If InStr(CStr(.Fields(intCol).Value), " ") Then
                                            'strXML = strXML & Left$(CStr(.Fields(intCol).Value), InStr(CStr(.Fields(intCol).Value), " ") - 1)
                                        End If
                                    Else
                                        strXML = strXML & CStr(.Fields(intCol).Value)
                                    End If
                                    strXML = strXML & "</" & CStr(.Fields(intCol).Name) & ">" & vbCrLf
                                End If
                            Next intCol
                            strXML = strXML & "   </Header>" & vbCrLf
                            strXML = strXML & "   <BillingAddr>" & vbCrLf
                            strXML = strXML & Space(6) & "<CompanyName>OakLeaf Consumer Electronics</CompanyName>" & vbCrLf
                            strXML = strXML & Space(6) & "<Attention>Accounts Payable</Attention>" & vbCrLf
                            strXML = strXML & Space(6) & "<Address>415 W. Jefferson</Address>" & vbCrLf
                            strXML = strXML & Space(6) & "<City>Dallas</City>" & vbCrLf
                            strXML = strXML & Space(6) & "<State>TX</State>" & vbCrLf
                            strXML = strXML & Space(6) & "<ZIPCode>75208</ZIPCode>" & vbCrLf
                            strXML = strXML & Space(6) & "<Phone>214-555-2345</Phone>" & vbCrLf
                            strXML = strXML & "   </BillingAddr>" & vbCrLf
                            strXML = strXML & "   <ShippingAddr>" & vbCrLf
                            If CBool(.Fields("ShipToCustomer").Value) Then
                                For intCol = 6 To 10
                                    strXML = strXML & Space(6) & "<" & CStr(.Fields(intCol).Name) & ">" & CStr(.Fields(intCol).Value) & "</" & CStr(.Fields(intCol).Name) & ">" & vbCrLf
                                    If intCol = 6 Then
                                        'Not for customer shipments
                                        strXML = strXML & Space(6) & "<ShipAttn></ShipAttn>" & vbCrLf
                                    End If
                                Next intCol
                            Else
                                strXML = strXML & Space(6) & "<ShipName>OakLeaf Consumer Electronics</ShipName>" & vbCrLf
                                strXML = strXML & Space(6) & "<ShipAttn>Receiving Dept.</ShipAttn>" & vbCrLf
                                strXML = strXML & Space(6) & "<ShipAddress>2623 S Garland Ave.</ShipAddress>" & vbCrLf
                                strXML = strXML & Space(6) & "<ShipCity>Garland</ShipCity>" & vbCrLf
                                strXML = strXML & Space(6) & "<ShipState>TX</ShipState>" & vbCrLf
                                strXML = strXML & Space(6) & "<ShipZIPCode>75041</ShipZIPCode>" & vbCrLf
                                strXML = strXML & Space(6) & "<ShipPhone>972-555-1234</ShipPhone>" & vbCrLf
                            End If
                            strXML = strXML & "   </ShippingAddr>" & vbCrLf
                            strXML = strXML & "   <LineItems>" & vbCrLf
                            With rstItems
                                Do Until .EOF
                                    strXML = strXML & Space(6) & "<Item>" & vbCrLf
                                    For intCol = 1 To CShort(.Fields.Count) - 1
                                        strXML = strXML & Space(9) & "<" & CStr(.Fields(intCol).Name) & ">" & CStr(.Fields(intCol).Value) & "</" & CStr(.Fields(intCol).Name) & ">" & vbCrLf
                                    Next intCol
                                    strXML = strXML & Space(6) & "</Item>" & vbCrLf
                                    .MoveNext()
                                Loop
                            End With
                            strXML = strXML & "   </LineItems>" & vbCrLf
                            If CBool(.Fields("ShipToCustomer").Value) Then
                                'Fix escaped "'", if present
                                strXML = strXML & Replace(CStr(.Fields("CustInvoice").Value), "''", "'")
                            End If
                            strXML = strXML & vbCrLf & "</PurchaseOrder>" & vbCrLf
                        End With
                    End If
                End If
            End If
        End With
        'Escape "&" with "and", not an entity
        strXML = Replace(strXML, "&", "and")

        'Check wellformedness and send the order to the distributor
        Dim objAlphaOrder As New AlphaDist.clsAlphaDist()
        Dim objBetaOrder As New BetaDist.clsBetaDist()
        Dim objGammaOrder As New GammaDist.clsGammaDist()
        With docOrder
            If blnUseOakLeaf Then
                If blnUseCom Then
                    'Same IPs for all distributors
                    strServiceURL = "http://66.123.163.243/"
                Else
                    strServiceURL = "http://www.oakleaf.ws/"
                End If
            Else
                strServiceURL = "http://localhost/"
            End If

            'Test for parse errors
            .loadXML(strXML)
            If .parseError.errorCode = 0 Then
                Select Case strDatabase
                    Case "AlphaDist"
                        If blnUseWS Then
                            If blnUseOakLeaf Then
                              If blnUseCom Then
                                 strXML = comAlphaWS.PlaceOrder(strServer, strDatabase, strUserName, strPassword, strXML, True)
                              Else
                                 strXML = remAlphaWS.PlaceOrder(strServer, strDatabase, strUserName, strPassword, strXML, True)
                              End If
                            Else
                              strXML = objAlphaWS.PlaceOrder(strServer, strDatabase, strUserName, strPassword, strXML, True)
                            End If
                        Else
                            strXML = objAlphaOrder.PlaceOrder(strServer, strDatabase, strUserName, strPassword, strXML, False)
                        End If
                    Case "BetaDist"
                        If blnUseWS Then
                           If blnUseOakLeaf Then
                              If blnUseCom Then
                                 strXML = comBetaWS.PlaceOrder(strServer, strDatabase, strUserName, strPassword, strXML, True)
                              Else
                                 strXML = remBetaWS.PlaceOrder(strServer, strDatabase, strUserName, strPassword, strXML, True)
                              End If
                           Else
                              strXML = objBetaWS.PlaceOrder(strServer, strDatabase, strUserName, strPassword, strXML, True)
                           End If
                        Else
                            strXML = objBetaOrder.PlaceOrder(strServer, strDatabase, strUserName, strPassword, strXML, False)
                        End If
                    Case "GammaDist"
                        If blnUseWS Then
                           If blnUseOakLeaf Then
                              If blnUseCom Then
                                 strXML = comGammaWS.PlaceOrder(strServer, strDatabase, strUserName, strPassword, strXML, True)
                              Else
                                 strXML = remGammaWS.PlaceOrder(strServer, strDatabase, strUserName, strPassword, strXML, True)
                              End If
                           Else
                              strXML = objGammaWS.PlaceOrder(strServer, strDatabase, strUserName, strPassword, strXML, True)
                           End If
                        Else
                            strXML = objGammaOrder.PlaceOrder(strServer, strDatabase, strUserName, strPassword, strXML, False)
                        End If
                End Select
                If blnUseWS Then
                    strResponse = strXML
                    If Err.Number = 0 And Len(SendPurchaseOrder) = 0 Then
                        .loadXML(strResponse)
                        If .parseError.errorCode = 0 Then
                            SendPurchaseOrder = strResponse
                        Else
                            SendPurchaseOrder = "Error: Parse error '" & .parseError.reason & "' in response document from " & strDatabase & "."
                        End If
                    ElseIf Err.Number <> 0 Then
                        SendPurchaseOrder = "ERROR: " & Err.Description
                    End If
                Else
                    If Err.Number = 0 Then
                        SendPurchaseOrder = strResponse
                    Else
                        SendPurchaseOrder = "ERROR: " & Err.Description
                    End If
                End If
            Else
                SendPurchaseOrder = "Error: Parse error '" & .parseError.reason & "' in order document."
            End If
        End With
    End Function
End Class