Option Strict On
Option Explicit On
Public Interface _clsGammaDist
	Function CheckStock(ByVal strServer As String, ByVal strDatabase As String, ByVal strUser As String, ByVal strPassword As String, ByVal strSKU As String, ByVal blnXML As Boolean) As String
	Function PlaceOrder(ByVal strServer As String, ByVal strDatabase As String, ByVal strUser As String, ByVal strPassword As String, ByVal strXML As String, ByVal blnXML As Boolean) As String
End Interface
<System.Runtime.InteropServices.ProgId("clsGammaDist_NET.clsGammaDist")> Public Class clsGammaDist
	Implements _clsGammaDist
	
	Public Function CheckStock(ByVal strServer As String, ByVal strDatabase As String, ByVal strUser As String, ByVal strPassword As String, ByVal strSKU As String, ByVal blnXML As Boolean) As String Implements _clsGammaDist.CheckStock
		
		'Query distributor CheckStock
		'Returns cookie-formatted string with quantity on hand
		'This function is the same for each distributor
		
		Dim cnnInventory As New ADODB.Connection
		Dim rstInventory As New ADODB.Recordset
		Dim rstAllowDisc As New ADODB.Recordset
		Dim strConn As String
		Dim strSQL As String
		Dim strXML As String
		Dim intCol As Short
		
		On Error Resume Next
		
		strConn = "Provider=SQLOLEDB;Data Source=" & strServer & ";Initial Catalog=" & strDatabase & ";UID=" & strUser & ";PWD=" & strPassword
		cnnInventory.Open(strConn)
		
		If Err.Number = 0 Then
			'Get the product data
			strSQL = "SELECT * FROM Products WHERE SKU = '" & strSKU & "'"
			rstInventory = cnnInventory.Execute(strSQL,  , ADODB.CommandTypeEnum.adCmdText)
			With rstInventory
				If .EOF Then
					CheckStock = "Error: " & strDatabase & " doesn't recognize SKU " & strSKU
				Else
					If blnXML Then
						'Serialize report
						strXML = "<" & strDatabase & "Inventory>" & vbCrLf
						For intCol = 0 To 4
							strXML = strXML & "   <" & CStr(.Fields(intCol).Name) & ">" & CStr(.Fields(intCol).Value) & "</" & CStr(.Fields(intCol).Name) & ">" & vbCrLf
						Next intCol
						For intCol = 5 To 7
							strXML = strXML & "   <" & CStr(.Fields(intCol).Name) & ">"
							'UPGRADE_WARNING: Use of Null/IsNull() detected. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1049"'
							If IsDbNull(.Fields(intCol).Value) Then
								'Do nothing
							ElseIf intCol = 7 Then 
								'Weight
								strXML = strXML & CStr(.Fields(intCol).Value) & " lbs"
							Else
								'Money
                                strXML = strXML & Format(CDec(.Fields(intCol).Value), "$#,##0.00")
							End If
							strXML = strXML & "</" & CStr(.Fields(intCol).Name) & ">" & vbCrLf
						Next intCol
						For intCol = 9 To 12
							strXML = strXML & "   <" & CStr(.Fields(intCol).Name) & ">"
							'AllowanceID
                            If CDec(.Fields(9).Value) > 0 Then
                                If intCol = 9 Then
                                    strXML = strXML & CStr(.Fields(9).Value)
                                ElseIf intCol = 10 Then
                                    strXML = strXML & Format(CDec(.Fields(10).Value), "$#,##0.00")
                                End If
                            End If
                            If CByte(.Fields(11).Value) > 0 Then
                                If intCol = 11 Then
                                    strXML = strXML & CStr(.Fields(11).Value)
                                ElseIf intCol = 12 Then
                                    strXML = strXML & Format(CSng(.Fields(12).Value), "#0.0%")
                                End If
                            End If
                            strXML = strXML & "</" & CStr(.Fields(intCol).Name) & ">" & vbCrLf
                            If intCol = 10 Or intCol = 12 Then
                                'Add the allowance type element
                                If intCol = 10 Then
                                    strXML = strXML & "   <AllowanceType>"
                                Else
                                    strXML = strXML & "   <DiscountType>"
                                End If
                                If (CByte(.Fields(9).Value) > 0 And intCol = 10) Or (CByte(.Fields(11).Value) > 0 And intCol = 12) Then
                                    strSQL = "SELECT * FROM AllowancesDiscounts WHERE AllowDiscID = " & CStr(.Fields(intCol - 1).Value)
                                    rstAllowDisc = cnnInventory.Execute(strSQL, , ADODB.CommandTypeEnum.adCmdText)
                                    If Not rstAllowDisc.EOF Then
                                        strXML = strXML & CStr(rstAllowDisc.Fields(1).Value)
                                    End If
                                End If
                                If intCol = 10 Then
                                    strXML = strXML & "</AllowanceType>"
                                Else
                                    strXML = strXML & "</DiscountType>"
                                End If
                                strXML = strXML & vbCrLf
                            End If
                        Next intCol
						intCol = 8
						strXML = strXML & "   <" & CStr(.Fields(intCol).Name) & "InStock>" & CStr(.Fields(intCol).Value) & "</" & CStr(.Fields(intCol).Name) & "InStock>" & vbCrLf
						strXML = strXML & "   <DateTime>" & CStr(Now) & "</DateTime>" & vbCrLf
						strXML = strXML & "</" & strDatabase & "Inventory>" & vbCrLf
						CheckStock = strXML
					Else
						'Return string is cookie format
						CheckStock = strDatabase & " CheckStock for SKU=" & strSKU & ";Category=" & CStr(.Fields(1).Value) & ";Brand=" & CStr(.Fields(2).Value) & ";Model=" & CStr(.Fields(3).Value) & ";Description=" & CStr(.Fields(4).Value) & ";"
						'UPGRADE_WARNING: Use of Null/IsNull() detected. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1049"'
						If Not IsDbNull(.Fields(5).Value) Then
                            CheckStock = CheckStock & "MSRP=" & Format(CDec(.Fields(5).Value), "$#,##0.00") & ";"
						End If
                        CheckStock = CheckStock & "NetPrice=" & Format(CDec(.Fields(6).Value), "$#,##0.00") & ";ShipWeight=" & CStr(.Fields(7).Value) & " lbs"
						If CByte(.Fields(9).Value) > 0 Then
							strSQL = "SELECT * FROM AllowancesDiscounts WHERE AllowDiscID = " & CStr(.Fields(9).Value)
							rstAllowDisc = cnnInventory.Execute(strSQL,  , ADODB.CommandTypeEnum.adCmdText)
							If rstAllowDisc.EOF Then
								'Not a critical error
							Else
                                CheckStock = CheckStock & ";AllowanceFor=" & CStr(rstAllowDisc.Fields(1).Value) & ";Amount=" & Format(CDec(.Fields(10).Value), "$#,##0.00")
							End If
							rstAllowDisc.Close()
						End If
						If CByte(.Fields(11).Value) > 0 Then
							strSQL = "SELECT * FROM AllowancesDiscounts WHERE AllowDiscID = " & CStr(.Fields(11).Value)
							rstAllowDisc = cnnInventory.Execute(strSQL,  , ADODB.CommandTypeEnum.adCmdText)
							If rstAllowDisc.EOF Then
								'Not critical
							Else
                                CheckStock = CheckStock & ";DiscountFor=" & CStr(rstAllowDisc.Fields(1).Value) & ";Percent=" & Format(CSng(.Fields(10).Value), "#0.0%")
							End If
							rstAllowDisc.Close()
						End If
						CheckStock = CheckStock & ";InStock=" & CStr(.Fields(8).Value)
					End If
				End If
			End With
		Else
			CheckStock = "ERROR: " & Err.Description
		End If
		rstInventory.Close()
		'UPGRADE_NOTE: Object rstInventory may not be destroyed until it is garbage collected. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1029"'
		rstInventory = Nothing
		'UPGRADE_NOTE: Object rstAllowDisc may not be destroyed until it is garbage collected. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1029"'
		rstAllowDisc = Nothing
		cnnInventory.Close()
		'UPGRADE_NOTE: Object cnnInventory may not be destroyed until it is garbage collected. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1029"'
		cnnInventory = Nothing
	End Function
	
	
	Public Function PlaceOrder(ByVal strServer As String, ByVal strDatabase As String, ByVal strUser As String, ByVal strPassword As String, ByVal strXML As String, ByVal blnXML As Boolean) As String Implements _clsGammaDist.PlaceOrder
		
		'Send purchase order to distributor as XML document
		'Return invoice if order processed, updated order if not
		'(This procedure is identical for each distributor)
		
		Dim cnnOrder As New ADODB.Connection
		Dim rstOrder As New ADODB.Recordset
		Dim docOrder As New MSXML2.DOMDocument40
		Dim lstNodes As MSXML2.IXMLDOMNodeList
		Dim nodParent As MSXML2.IXMLDOMNode
		Dim nodChild As MSXML2.IXMLDOMNode
		Dim nodBackOrd As MSXML2.IXMLDOMNode
		Dim nodInvoice As MSXML2.IXMLDOMNode
		
		Dim strOrderConn As String
		Dim strCustInvoice As String
		Dim strOrderID As String
		Dim strOrderDate As String
		Dim strPartShip As String
		Dim strQuan As String
		Dim astrItems(10, 2) As String
      Dim intItems As Integer
      Dim intCtr As Integer
		Dim strSQL As String
      Dim lngReccnt As Object
		Dim strRetMsg As String
		Dim blnAllInStock As Boolean
		
		On Error Resume Next
		
		With docOrder
			.loadXML(strXML)
			If .parseError.errorCode <> 0 Then
				PlaceOrder = "Error: Parse error '" & .parseError.reason & "' in order document"
				GoTo ExitPlaceOrder
			End If
		End With
		
		'Connect to the distributor database
		strOrderConn = "Provider=SQLOLEDB;Data Source=" & strServer & ";Initial Catalog=" & strDatabase & ";UID=" & strUser & ";PWD=" & strPassword
		cnnOrder.Open(strOrderConn)
		If Err.Number <> 0 Then
			'Can't connect
			PlaceOrder = "Error: Can't connect to " & strServer & " database."
			GoTo ExitPlaceOrder
		End If
		
		'Remove and save the customer invoice for printing (just removed here)
		If InStr(strXML, "<CustomerInvoice>") > 0 Then
			strCustInvoice = "   " & Mid(strXML, InStr(strXML, "<CustomerInvoice>"))
			strCustInvoice = Left(strXML, InStr(strXML, "</CustomerInvoice>") + 17)
			strXML = Trim(Left(strXML, InStr(strXML, "<CustomerInvoice>") - 1))
			strXML = strXML & "</PurchaseOrder>"
		End If
		With docOrder
			If Len(strCustInvoice) > 0 Then
				'Reload the document without the customer invoice
				.loadXML(strXML)
				If .parseError.errorCode <> 0 Then
					PlaceOrder = "Error: Parse error '" & .parseError.reason & "' in order document"
					GoTo ExitPlaceOrder
				End If
			End If
			
			'Return string headers
			lstNodes = .getElementsByTagName("PurchID")
			nodParent = lstNodes.Item(0)
			strOrderID = nodParent.Text
			lstNodes = .getElementsByTagName("OrderDate")
			nodParent = lstNodes.Item(0)
			strOrderDate = nodParent.Text
            If InStr(strOrderDate, " ") > 0 Then
                'Trim the time
                strOrderDate = Left(strOrderDate, InStr(strOrderDate, " ") - 1)
            End If
            lstNodes = .getElementsByTagName("PartialShipOK")
            nodParent = lstNodes.item(0)
            strPartShip = nodParent.text

            lstNodes = .getElementsByTagName("SKU")
            'Create an array of SKUs and quantities for inventory test
            intItems = lstNodes.length - 1
            For intCtr = 0 To intItems
                nodParent = lstNodes.item(intCtr)
                astrItems(intCtr, 0) = nodParent.text
            Next intCtr
            lstNodes = .getElementsByTagName("Quantity")
            For intCtr = 0 To intItems
                nodParent = lstNodes.item(intCtr)
                astrItems(intCtr, 1) = nodParent.text
            Next intCtr
        End With
		
		blnAllInStock = True
		For intCtr = 0 To intItems
			'Check SKU current inventory
			strSQL = "SELECT Quantity FROM Products WHERE SKU='" & astrItems(intCtr, 0) & "'"
			rstOrder = cnnOrder.Execute(strSQL,  , ADODB.CommandTypeEnum.adCmdText)
			With rstOrder
				If .EOF Then
					PlaceOrder = "Error: " & strServer & " has no record of SKU '" & astrItems(intCtr, 0) & "'"
					GoTo ExitPlaceOrder
				Else
					strRetMsg = strRetMsg & "SKU=" & astrItems(intCtr, 0) & ";"
					If CShort(.Fields(0).Value) >= CShort(astrItems(intCtr, 1)) Then
						'Decrement the inventory quantity for the product
						strSQL = "UPDATE Products SET Quantity = Quantity - 1 " & "WHERE SKU='" & astrItems(intCtr, 0) & "'"
						'Note that DistUser is allowed to update distributor database at this point
                  cnnOrder.Execute(strSQL, CInt(lngReccnt), ADODB.CommandTypeEnum.adCmdText)
                  If CInt(lngReccnt) = 0 Then
                     'Internal distributor error
                     'Not handled at this point
                  End If
               Else
                  'Out of stock
                  astrItems(intCtr, 1) = "0"
                  blnAllInStock = False
               End If
				End If
				.Close()
			End With
		Next intCtr
		
		If blnXML Then
			lstNodes = docOrder.getElementsByTagName("Item")
			For intCtr = 0 To lstNodes.length - 1
				nodParent = lstNodes.Item(intCtr)
				'Quantity child node
				nodChild = nodParent.childNodes(1)
				strQuan = nodChild.Text
				nodChild.Text = astrItems(intCtr, 1)
				
				'Status child node
				nodChild = nodParent.childNodes(8)
				If blnAllInStock Then
					nodChild.Text = "59"
				Else
					If astrItems(intCtr, 1) = "0" And strPartShip = "True" Then
						nodChild.Text = "51"
					Else
						nodChild.Text = "88"
					End If
				End If
				
				'Add the Backordered node to each line item
				nodBackOrd = docOrder.createElement("Backordered")
				If blnAllInStock Then
					nodBackOrd.Text = "0"
				ElseIf strPartShip = "True" And astrItems(intCtr, 1) = "0" Then 
					nodBackOrd.Text = strQuan
				Else
					nodBackOrd.Text = "0"
				End If
				nodParent.appendChild(nodBackOrd)
			Next intCtr
			
			'Add the OrderStatus element and value
			nodChild = docOrder.createElement("OrderStatus")
			If blnAllInStock Then
				nodChild.Text = "Shipment Complete (59)"
			ElseIf strPartShip = "True" And astrItems(intCtr, 1) = "0" Then 
				nodChild.Text = "Partial Shipment 1 (51)"
			Else
				nodChild.Text = "Canceled (88)"
			End If
			lstNodes = docOrder.getElementsByTagName("Header")
			nodParent = lstNodes.Item(0)
			nodParent.appendChild(nodChild)
			
			If blnAllInStock Or strPartShip = "True" Then
				'Add the invoice date first to simplify adding the invoice number
				nodChild = docOrder.createElement("InvoiceDate")
				nodChild.Text = CStr(Today)
				lstNodes = docOrder.getElementsByTagName("Header")
				nodParent = lstNodes.Item(0)
				nodInvoice = lstNodes.Item(0).firstChild
				nodParent.insertBefore(nodChild, nodInvoice)
				
				'Add the distributor invoice number
				nodChild = docOrder.createElement("InvoiceID")
				'Use random distributor invoice numbers for simplicity
				nodChild.Text = CStr(1000000 + Int(100000 * Rnd()))
				lstNodes = docOrder.getElementsByTagName("Header")
				nodParent = lstNodes.Item(0)
				nodInvoice = lstNodes.Item(0).firstChild
				nodParent.insertBefore(nodChild, nodInvoice)
			End If
			
			strXML = docOrder.xml
			'Fix up the formatting of the added elements
			strXML = Replace(strXML, "</InvoiceID>", "</InvoiceID>" & vbCrLf & Space(6))
			strXML = Replace(strXML, "</InvoiceDate>", "</InvoiceDate>" & vbCrLf & Space(6))
			strXML = Replace(strXML, "</Backordered>", "</Backordered>" & vbCrLf & Space(6))
			strXML = Replace(strXML, "</OrderStatus>", "</OrderStatus>" & vbCrLf & Space(3))
			If blnAllInStock Or strPartShip = "True" Then
				'Generate an invoice
				strXML = Replace(strXML, "PurchaseOrder>", "Invoice>")
			End If
			PlaceOrder = strXML
		Else
			strRetMsg = "OrderID=" & strOrderID & ";Date=" & strOrderDate & ";"
			For intCtr = 0 To intItems
				strRetMsg = strRetMsg & "Item=" & CStr(intCtr + 1) & ";SKU=" & astrItems(intCtr, 0)
				If blnAllInStock Then
					strRetMsg = strRetMsg & ";Shipped=" & astrItems(intCtr, 1)
				ElseIf strPartShip = "True" And astrItems(intCtr, 1) = "0" Then 
					strRetMsg = strRetMsg & ";Backordered=" & astrItems(intCtr, 1)
				Else
					strRetMsg = strRetMsg & ";Shipped=0"
				End If
			Next intCtr
			If blnAllInStock Then
				strRetMsg = strRetMsg & ";Status=Complete"
			ElseIf strPartShip = "True" And astrItems(intCtr, 1) = "0" Then 
				strRetMsg = strRetMsg & ";Status=PartialShipment"
			Else
				strRetMsg = strRetMsg & ";Status=Canceled"
			End If
			PlaceOrder = strRetMsg
		End If
		
ExitPlaceOrder: 
		'Cleanup
		'UPGRADE_NOTE: Object docOrder may not be destroyed until it is garbage collected. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1029"'
		docOrder = Nothing
		'UPGRADE_NOTE: Object lstNodes may not be destroyed until it is garbage collected. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1029"'
		lstNodes = Nothing
		'UPGRADE_NOTE: Object nodParent may not be destroyed until it is garbage collected. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1029"'
		nodParent = Nothing
		'UPGRADE_NOTE: Object nodChild may not be destroyed until it is garbage collected. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1029"'
		nodChild = Nothing
		'UPGRADE_NOTE: Object nodBackOrd may not be destroyed until it is garbage collected. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1029"'
		nodBackOrd = Nothing
		'UPGRADE_NOTE: Object nodInvoice may not be destroyed until it is garbage collected. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1029"'
		nodInvoice = Nothing
		
		With rstOrder
			If .State = ADODB.ObjectStateEnum.adStateOpen Then
				.Close()
			End If
		End With
		'UPGRADE_NOTE: Object rstOrder may not be destroyed until it is garbage collected. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1029"'
		rstOrder = Nothing
		With cnnOrder
			If .State = ADODB.ObjectStateEnum.adStateOpen Then
				.Close()
			End If
		End With
		'UPGRADE_NOTE: Object cnnOrder may not be destroyed until it is garbage collected. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1029"'
		cnnOrder = Nothing
	End Function
End Class