Option Explicit On 
Option Strict On

Imports System.Web.Services

<WebService(Namespace:="http://omegabank.com/webservices/", _
   Description:="The OmegaBank Network is a (fictional) full-service credit and debit card transaction-processing facility for merchants accepting American Express, Discover, MasterCharge, and VISA cards. The OmegaBank Web service's VerifyOrHold method enables merchants to verify credit availability and place holds against available credit. The ChargeOrCredit method debits or credits the specified cardholder's account, and releases the credit hold based on its transaction ID.")> _
Public Class OmegaBank
    Inherits System.Web.Services.WebService

#Region " Web Services Designer Generated Code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Web Services Designer.
        InitializeComponent()

        'Add your own initialization code after the InitializeComponent() call

    End Sub

    'Required by the Web Services Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Web Services Designer
    'It can be modified using the Web Services Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        components = New System.ComponentModel.Container()
    End Sub

    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        'CODEGEN: This procedure is required by the Web Services Designer
        'Do not modify it using the code editor.
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

#End Region
   <WebMethod(Description:="<html><p>The VerifyOrHold method requires the following parameter values. OmegaBank provides you with the values for parameters with an asterisk (*) when you complete your service agreement.</p>" & _
         "[1] strServer: The name of the network server* (xsd:string) <br />" & _
         "[2] strUser: Your assigned login ID* (xsd:string) <br />" & _
         "[3] strPwd: Your assigned login password*  (xsd:string) <br />" & _
         "[4] lngMerchantID: Your merchant ID for the specified issuer (xsd:integer) <br />" & _
         "[5] lngRefNum: Your transaction reference, such as an order number (xsd:integer) <br />" & _
         "[6] strIssuer: AMEX, DISC, MAST, or VISA (xsd:string) <br />" & _
         "[7] strCardNumber: All 16 digits of the card number with no hyphens or spaces (xsd:string) <br />" & _
         "[8] strCardName: The cardholder's name as it appears on the card (xsd:string) <br />" & _
         "[9] strZipCode: The cardholders ZIP or ZIP+4 code (xsd:string) <br />" & _
         "[10] strExpDate: The card expiration date in MM-YY format (xsd:string) <br />" & _
         "[11] curTransactAmt: The amount to verify or hold, in ####.## format (xsd:decimal) <br />" & _
         "[12] blnApplyHold: False to verify, True to hold (xsd:boolean) <br />" & _
         "[13] blnUseWS: Always True (xsd:boolean) <br />" & _
         "[Verify Response] If credit availibility is greater than the transaction amount, the service returns the following string: <br />" & _
         "'407162 Verify Code: 705OMB53342 (12)'. The initial number is your lngRefNum value. <br />" & _
         "[Declined Response] If credit availibility is less than the transaction amount, the service returns the following string: <br />" & _
         "'407166 Declined: Insufficient credit available (14)'. Your merchant agreement describes other transaction declined responses. <br />" & _
         "[Hold Response] If credit availability is greater than the transaction amount, the service returns the following string: <br />" & _
         "'407168 Hold on $726.23 applied by TRID 5287716 (12)'. You use the transaction ID (TRID) when debiting the card for the hold amount or less. <br />" & _
         "Otherwise, the string returns a declined response.</html>")> _
      Public Function VerifyOrHold(ByVal strServer As String, ByVal strUser As String, ByVal strPwd As String, ByVal lngMerchantID As Integer, ByVal lngRefNum As Integer, ByVal strIssuer As String, ByVal strCardNumber As String, ByVal strCardName As String, ByVal strZipCode As String, ByVal strExpDate As String, ByVal curTransactAmt As Decimal, ByVal blnApplyHold As Boolean, ByVal blnUseWS As Boolean) As String

      'Verify credit card data, credit availability, and apply holds
      'Returns a string with denied or approved information

      Dim cnnVerify As New ADODB.Connection()
      Dim rstVerify As New ADODB.Recordset()

      Dim strNetConn As String
      Dim strSQL As String
      Dim strExpMonth As String
      Dim strExpYear As String
      Dim datExpDate As Date
      Dim lngTransactID As Integer
      Dim lngReccnt As Object
      Dim strDateTime As String
      Dim curAvailable As Decimal

      On Error Resume Next

      strNetConn = "Provider=SQLOLEDB;Data Source=" & strServer & ";Initial Catalog=OMB_Network;UID=" & strUser & ";PWD=" & strPwd
      cnnVerify.Open(strNetConn)
      If Err.Number <> 0 Then
         VerifyOrHold = "ERROR: " & Err.Description & " (" & Err.Number & ")"
         GoTo exitVerifyOrHold
      End If

      'Check merchant account
      strSQL = "SELECT COUNT(MerchantID) FROM Merchants " & "WHERE MerchantID = " & CStr(lngMerchantID)
      rstVerify = cnnVerify.Execute(strSQL, , ADODB.CommandTypeEnum.adCmdText)
      With rstVerify
         If CInt(.Fields(0).Value) = 0 Then
            VerifyOrHold = "Error: Merchant account " & CStr(lngMerchantID) & " not found."
            GoTo exitVerifyOrHold
         Else
            .Close()
         End If
      End With

      'Check credit-card status
      strSQL = "SELECT Canceled, Issuer, CardName, ZipCode, ExpDate, Available " & "FROM Authorize WHERE CardNumber = '" & strCardNumber & "'"
      rstVerify = cnnVerify.Execute(strSQL, , ADODB.CommandTypeEnum.adCmdText)
      With rstVerify
         If .EOF Then
            VerifyOrHold = CStr(lngRefNum) & " Error: " & strIssuer & " Card number " & strCardNumber & " not found (0)."
         Else
            'Calculate expiration date (end of the month)
            strExpDate = CStr(.Fields(4).Value)
            strExpMonth = CStr(Val(Left(strExpDate, 2)))
            strExpYear = CStr(Val(Right(strExpDate, 2)))
            If CDbl(strExpMonth) = 12 Then
               strExpYear = CStr(CDbl(strExpYear) + 1)
            End If
            datExpDate = CDate(strExpMonth & "/01/" & strExpYear)
            curAvailable = CDec(.Fields(5).Value)

            'Initial credit-card check
            If CByte(.Fields(0).Value) = 1 Then
               VerifyOrHold = CStr(lngRefNum) & " Declined: " & strIssuer & " " & strCardNumber & " is canceled (19)"
            ElseIf CStr(.Fields(1).Value) <> strIssuer Then
               VerifyOrHold = CStr(lngRefNum) & " Declined: Issuer mismatch (18)"
            ElseIf CStr(.Fields(2).Value) <> strCardName Then
               VerifyOrHold = CStr(lngRefNum) & " Declined: Cardholder name mismatch (17)"
            ElseIf CStr(.Fields(3).Value) <> strZipCode Then
               VerifyOrHold = CStr(lngRefNum) & " Declined: Cardholder ZIP Code mismatch (16)"
            ElseIf CStr(.Fields(4).Value) <> strExpDate Then
               VerifyOrHold = CStr(lngRefNum) & " Declined: Expiration date mismatch (15)"
            ElseIf DateDiff(Microsoft.VisualBasic.DateInterval.Day, Today, datExpDate) < 1 Then
               VerifyOrHold = CStr(lngRefNum) & " Declined: Card expired " & CStr(.Fields(4).Value) & " (13)"
            End If
         End If
      End With
      rstVerify.Close()
      If Len(VerifyOrHold) > 0 Then
         GoTo exitVerifyOrHold
      End If

      'Get current available credit
      strSQL = "SELECT SUM(Amount) FROM Transactions WHERE CardNumber = '" & strCardNumber & "' AND AppliedToStatement IS NULL"
      rstVerify = cnnVerify.Execute(strSQL, , ADODB.CommandTypeEnum.adCmdText)
      With rstVerify
         If Not .EOF Then
            'Holds and charges are negative values
            'UPGRADE_WARNING: Use of Null/IsNull() detected. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1049"'
            If Not IsDBNull(.Fields(0).Value) Then
               curAvailable = curAvailable + CDec(.Fields(0).Value)
            End If
         End If
      End With

      'Check available credit
      If curAvailable < curTransactAmt Then
         VerifyOrHold = CStr(lngRefNum) & " Declined: Insufficient credit available (14)"
         GoTo exitVerifyOrHold
      Else
         VerifyOrHold = CStr(lngRefNum) & " Verify Code: " & CStr(Int(1000 * Rnd())) & "OMB" & CStr(Int(100000 * Rnd())) & " (12)"
      End If

      If blnApplyHold Then
         'Change to debit
         curTransactAmt = -curTransactAmt
         strDateTime = CStr(Now)
         'TypeID 31 is "Hold applied by merchant"
         strSQL = "INSERT Transactions(MerchantID, Reference, CardNumber, " & "TransactionDate, TransactionTypeID, Amount) " & "VALUES(" & CStr(lngMerchantID) & ", " & CStr(lngRefNum) & ", '" & strCardNumber & "', '" & strDateTime & "', 31, " & CStr(curTransactAmt) & ")"
         cnnVerify.Execute(strSQL, lngReccnt, ADODB.CommandTypeEnum.adCmdText)
         If CInt(lngReccnt) = 1 Then
            strSQL = "SELECT TransactionID FROM Transactions " & "WHERE Reference = " & CStr(lngRefNum) & " AND TransactionDate = '" & strDateTime & "'"
            rstVerify = cnnVerify.Execute(strSQL, , ADODB.CommandTypeEnum.adCmdText)
            With rstVerify
               If .EOF Then
                  VerifyOrHold = CStr(lngRefNum) & " Error: Unable to apply hold (99)"
               Else
                  lngTransactID = CInt(.Fields(0).Value)
                  VerifyOrHold = CStr(lngRefNum) & " Hold on " & Format(-curTransactAmt, "$#,##0.00") & " applied by TRID " & CStr(lngTransactID) & " (12)"
               End If
               .Close()
            End With
         Else
            VerifyOrHold = CStr(lngRefNum) & " Error: Unable to apply hold (99)"
         End If
      End If

exitVerifyOrHold:
         'Clean up
         With rstVerify
            If .State = ADODB.ObjectStateEnum.adStateOpen Then
               .Close()
            End If
         End With
         'UPGRADE_NOTE: Object rstVerify may not be destroyed until it is garbage collected. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1029"'
         rstVerify = Nothing
         With cnnVerify
            If .State = ADODB.ObjectStateEnum.adStateOpen Then
               .Close()
            End If
         End With
         'UPGRADE_NOTE: Object cnnVerify may not be destroyed until it is garbage collected. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1029"'
         cnnVerify = Nothing
   End Function

<WebMethod(Description:="<html><p>The ChargeOrCredit method requires the following parameter values. OmegaBank provides you with the values for parameters with an asterisk (*) when you complete your service agreement.</p>" & _
         "[1] strServer: The name of the network server* (xsd:string) <br />" & _
         "[2] strUser: Your assigned login ID* (xsd:string) <br />" & _
         "[3] strPwd: Your assigned login password*  (xsd:string) <br />" & _
         "[4] lngMerchantID: Your merchant ID for the specified issuer (xsd:integer) <br />" & _
         "[5] lngRefNum: Your transaction reference, such as an order number (xsd:integer) <br />" & _
         "[6] strCardNumber: All 16 digits of the card number with no hyphens or spaces (xsd:string) <br />" & _
         "[7] lngRelTransactID: The TRID value returned by the hold transaction (xsd:integer) <br />" & _
         "[8] curTransactAmt: The amount to verify or hold, in ####.## format (xsd:decimal) <br />" & _
         "[9] blnReleaseHold: True to release the entire amount held; False otherwise (xsd:boolean) <br />" & _
         "[10] blnCredit: True to issue a credit for the transaction amount; False to debit card (xsd:boolean) <br />" & _
         "[11] blnUseWS: Always True (xsd:boolean) <br />" & _
         "[Debit Response] If the charge transaction succeeds, you receive the following string: <br />" & _
         "'407168 Debit -$686.88 applied by TRID 5287718 (61)'. <br />" & _
         "[Credit Response] If the credit transaction succeeds, you receive the following string: <br />" & _
         "'407168 Credit $686.88 applied by TRID 5287722 (71)'. <br />" & _
         "Otherwise, the string returns a declined response, as described in your merchant agreement.</html>")> _
Public Function ChargeOrCredit(ByVal strServer As String, ByVal strUser As String, ByVal strPwd As String, ByVal lngMerchantID As Integer, ByVal lngRefNum As Integer, ByVal strCardNumber As String, ByVal lngRelTransactID As Integer, ByVal curTransactAmt As Decimal, ByVal blnReleaseHold As Boolean, ByVal blnCredit As Boolean, ByVal blnUseWS As Boolean) As String

      'Release/reduce hold and charge credit card

      Dim cnnCharge As New ADODB.Connection()
      Dim rstCharge As New ADODB.Recordset()

      Dim strNetConn As String
      Dim strSQL As String
      Dim lngReccnt As Object
      Dim strDateTime As String
      Dim strStatusID As String
      Dim curHoldAmt As Decimal
      Dim lngTransactID As Integer

      On Error Resume Next

      strNetConn = "Provider=SQLOLEDB;Data Source=" & strServer & ";Initial Catalog=OMB_Network;UID=" & strUser & ";PWD=" & strPwd
      cnnCharge.Open(strNetConn)
      If Err.Number <> 0 Then
         ChargeOrCredit = "ERROR: " & Err.Description & " (" & Err.Number & ")"
         GoTo exitChargeOrCredit
      End If

      strSQL = "SELECT COUNT(MerchantID) FROM Merchants " & "WHERE MerchantID = " & CStr(lngMerchantID)
      rstCharge = cnnCharge.Execute(strSQL, , ADODB.CommandTypeEnum.adCmdText)
      With rstCharge
         If CInt(.Fields(0).Value) = 0 Then
            ChargeOrCredit = "Error: Merchant account " & CStr(lngMerchantID) & " not found."
            GoTo exitChargeOrCredit
         Else
            .Close()
         End If
      End With

      strSQL = "SELECT * FROM Transactions WHERE TransactionID = " & CStr(lngRelTransactID)
      rstCharge = cnnCharge.Execute(strSQL, , ADODB.CommandTypeEnum.adCmdText)
      With rstCharge
         If .EOF Then
            ChargeOrCredit = "Error: Related transaction " & CStr(lngRelTransactID) & " not found."
            GoTo exitChargeOrCredit
         Else
            'TypeID 31 is "Hold applied by merchant"
            If CByte(.Fields("TransactionTypeID").Value) = 31 Then
               'More tests could be applied here
               strDateTime = CStr(Now)

               With cnnCharge
                  .BeginTrans()
                  If blnReleaseHold Then
                     strStatusID = CStr(35) 'Hold Removed by Merchant
                     curHoldAmt = -CDec(rstCharge.Fields("Amount").Value)
                  Else
                     strStatusID = CStr(34) 'Hold Reduced by Merchant
                     curHoldAmt = curTransactAmt
                  End If
                  strSQL = "INSERT Transactions(MerchantID, Reference, CardNumber, " & "TransactionDate, TransactionTypeID, Amount, RelatedTransactionID) " & "VALUES(" & CStr(lngMerchantID) & ", " & CStr(lngRefNum) & ", '" & strCardNumber & "', '" & strDateTime & "', 34, " & CStr(curHoldAmt) & ", " & CStr(lngRelTransactID) & ")"
                  .Execute(strSQL, lngReccnt, ADODB.CommandTypeEnum.adCmdText)
                  If CInt(lngReccnt) <> 1 Then
                     'Error
                     .RollbackTrans()
                     ChargeOrCredit = "Error: Unable to commit transaction " & CStr(lngRelTransactID) & " not found."
                     GoTo exitChargeOrCredit
                  End If
                  'StatusID 32 = Debit by Merchant
                  curTransactAmt = -curTransactAmt
                  strSQL = "INSERT Transactions(MerchantID, Reference, CardNumber, " & "TransactionDate, TransactionTypeID, Amount, RelatedTransactionID) " & "VALUES(" & CStr(lngMerchantID) & ", " & CStr(lngRefNum) & ", '" & strCardNumber & "', '" & strDateTime & "', 32, " & CStr(curTransactAmt) & ", " & CStr(lngRelTransactID) & ")"
                  .Execute(strSQL, lngReccnt, ADODB.CommandTypeEnum.adCmdText)
                  If CInt(lngReccnt) = 1 Then
                     .CommitTrans()
                  Else
                     ChargeOrCredit = CStr(lngRefNum) & " Error: Charge transaction didn't commit (99)"
                     .RollbackTrans()
                     GoTo exitChargeOrCredit
                  End If
               End With
            Else
               ChargeOrCredit = CStr(lngRefNum) & " Error: Status of reference transaction is not Apply Hold (99)"
               GoTo exitChargeOrCredit
            End If
         End If
      End With

      strSQL = "SELECT @@identity"
      rstCharge = cnnCharge.Execute(strSQL, , ADODB.CommandTypeEnum.adCmdText)
      With rstCharge
         If .EOF Then
            ChargeOrCredit = CStr(lngRefNum) & " Error: Unable to obtain Transaction ID (99)"
         Else
            lngTransactID = CInt(.Fields(0).Value)
            ChargeOrCredit = CStr(lngRefNum) & " Debit " & Format(curTransactAmt, "$#,##0.00") & " applied by TRID " & CStr(lngTransactID) & " (32)"
         End If
      End With

exitChargeOrCredit:
      'Clean up
      With rstCharge
         If .State = ADODB.ObjectStateEnum.adStateOpen Then
            .Close()
         End If
      End With
      With cnnCharge
         If .State = ADODB.ObjectStateEnum.adStateOpen Then
            .Close()
         End If
      End With
   End Function

End Class
